Bug 450458 - gthumb causes thrashing when importing large videos
gthumb causes thrashing when importing large videos
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gthumb (Show other bugs)
9
All Linux
low Severity low
: ---
: ---
Assigned To: Behdad Esfahbod
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-06-08 14:44 EDT by Pavel Polischouk
Modified: 2009-07-14 11:02 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-14 11:02:38 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Pavel Polischouk 2008-06-08 14:44:06 EDT
Description of problem:
When importing videos from USB/PTP still/video camera, gthumb causes system
thrashing by trying to read the whole video into memory (hundreds of megabytes,
or even several gigabytes)

Version-Release number of selected component (if applicable):
gthumb-2.10.8-3.fc9.i386
gphoto2-2.4.0-10.fc9.i386

How reproducible:
Always

Steps to Reproduce:
1. run gthumb --import-photos when usb/ptp camera is connected and contains a
large video.
  
Actual results:
Observe huge memory allocation and thrashing.

Expected results:
Should copy the file without allocating gigs of RAM.

Additional info:
The offending code is here:

        gp_file_new (&file);
    
        camera_folder = remove_level_from_path (camera_path);
        camera_filename = file_name_from_path (camera_path);
        gp_camera_file_get (data->camera,
                            camera_folder,
                            camera_filename,
                            GP_FILE_TYPE_NORMAL,
                            file,
                            data->context);
    
After gp_file_new, "file" argument becomes of type GP_FILE_ACCESSTYPE_MEMORY.
The in-memory file is then saved to disk by an extra call to gp_file_save. For
movies this is invalid - they can be very large and it's illegal to expect them
to fit into system memory in their entirety.

Instead, "file" should be initialized to type GP_FILE_ACCESSTYPE_FD and path
"local_path" and gp_camera_file_get will take care of saving it to hard drive,
without an extra call to gp_file_save.
Comment 1 Pavel Polischouk 2008-06-08 14:45:19 EDT
Forgot to mention - this code is in file dlg-photo-importer.c:1286.
Comment 2 Adam Gibson 2009-05-03 11:18:34 EDT
I just hit this same problem on Fedora Core 10.  I import 1 - 6 gig video files from my flash card.  I only have 1 gig of memory so GThumb ends up dying because it can not fit into memory or swap.  I am rather surprised that nobody else is complaining about this.

gthumb-2.10.10-3.fc10.x86_64
Comment 3 Bug Zapper 2009-06-09 21:29:08 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Bug Zapper 2009-07-14 11:02:38 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.